(set-logic LIA)
(define-fun R ((x Int) (y Int)) Bool
  (or (= y (- x 1)) (= y (- x 2)) (= y (- x 3)))
)
(assert
  (forall ((x1 Int))
    (exists ((y1 Int))
      (forall ((x2 Int))
        (exists ((y2 Int))
          (and
            (R x1 y1)
            (R y1 x2)
            (R x2 y2)
            (R y2 0)
          )
        )
      )
    )
  )
)
(check-sat)
