(set-logic LIA)
(define-fun R ((x Int) (y Int)) Bool
  (or (= y (- x 1)) (= y (- x 2)) (= y (- x 3)))
)
(assert
  (forall ((x Int))    (exists ((w Int))
      (=>
        (= (+ w w w w) x)
        (forall ((z Int))
          (exists ((y Int))
            (=>
              (R x z)
              (and
                (R z y)
                (exists ((w Int)) (= (+ w w w w) y))
              )
            )
          )
        )
      )
    )
  )
)
(check-sat)
